package jp.chiheisen;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * NX̍\͂NXłB
 * 
 * @version 1.00, 10/10/10
 */
public class ClassParser {
	
	/**
	 * w肵NXɊ܂܂郁\bhׂĎ擾܂B <br>
	 * (Deprecated Ame[VĂNXE\bh͏O܂)
	 * 
	 * @param classNameList NX̃Xg
	 * @param classModifiers Ώۂ̃NXCq
	 * @param methodModifiers Ώۂ̃ANZXCq
	 * @return \bh̃Xg
	 * @throws ClassNotFoundException NXȂƂ
	 */
	public static List<String> getMethodNameList(List<String> classNameList, 
			int classModifiers, int methodModifiers)
			throws ClassNotFoundException {
		List<String> methodNameList = new ArrayList<String>();
		for (String className : classNameList) {
			methodNameList.addAll(getMethodName(className, classModifiers, methodModifiers));
		}

		return methodNameList;
	}

	private static Set<String> getMethodName(String className, int classModifiers, int methodModifiers)
			throws ClassNotFoundException {
		ClassLoader classLoader = ClassLoader.getSystemClassLoader();
		Class<?> clazz = classLoader.loadClass(className);

		Set<String> methodName = new HashSet<String>();
		if ((classModifiers & clazz.getModifiers()) != 0 &&
				clazz.getAnnotation(Deprecated.class) == null){
			for (Method method : clazz.getMethods()) {
				if ((methodModifiers & method.getModifiers()) != 0 &&
						method.getAnnotation(Deprecated.class) == null){
					methodName.add(method.getName());
				}
			}
		}

		return methodName;
	}
}
