package jp.chiheisen;

import java.io.IOException;
import java.util.ArrayList;
import java.util.EnumSet;
import java.util.List;
import java.util.Set;
import java.util.regex.Matcher;

import javax.tools.DiagnosticCollector;
import javax.tools.JavaCompiler;
import javax.tools.JavaFileManager;
import javax.tools.JavaFileObject;
import javax.tools.StandardLocation;
import javax.tools.ToolProvider;

/**
 * pbP[W̍\͂NXłB
 * 
 * @version 1.00, 10/10/10
 */
public class PackageParser{

	/**
	 * w肵pbP[WɊ܂܂邷ׂẴNX̊S擾܂B <br>
	 * ̃\bhĂяoۂ́AJDK(Java Developers Kit)KvłB <br>
	 * JRE(Java Runtime Edition)ł́ANullPointerException ܂B
	 * ({@link ToolProvider#getSystemJavaCompiler()}  null Ԃ߂ł)
	 * <br>
	 * ̃\bh́Aȉ̃TCgQlɍ쐬܂B<br>
	 * wpbP[W̃NXꗗ擾Tv - Ȃ̓L<br>
	 * http://d.hatena.ne.jp/unageanu/20100107/1262869452<br>
	 * 
	 * @param classNameList NX̃Xg
	 * @param classModifiers Ώۂ̃NXCq
	 * @param methodModifiers Ώۂ̃ANZXCq
	 * @return NX̊S̃Xg
	 * @throws IOException pbP[W̊܂܂t@CǂݎȂ
	 */
	public static List<String> getClassNameList(List<String> packageNameList) throws IOException {
		JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
		JavaFileManager fm = compiler.getStandardFileManager(
		    new DiagnosticCollector<JavaFileObject>(), null, null);

		// ꗗɊ܂߂IuWFNgʁBȉ̓NX݂̂܂߂B
		Set<JavaFileObject.Kind> kind = EnumSet.of(JavaFileObject.Kind.CLASS);

		// u[gNXpXAwpbP[Wȉ̃NXꗗ擾B
		List<String> classNameList = new ArrayList<String>();
		for(String packageName : packageNameList){
			for ( JavaFileObject f : fm.list(StandardLocation.PLATFORM_CLASS_PATH, packageName, kind, true)) {
				// f.toStirng() -> java\io\Bits.class(java\io:Bits.class)
				String str = f.toString();
				String path = str.substring(0, str.indexOf(".class"));
				classNameList.add(path.replaceAll(Matcher.quoteReplacement("\\"), "."));
			}
		}
		
		return classNameList;
	}
}
