package jp.chiheisen.util;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

/**
 * }bṽL[Ƃɏo񐔂JEgNXłB
 *
 * @param <T> L[̌^
 * @version 1.00, 10/10/10
 */
public class MapCounter<T>{
	/** JEg */
	private Map<T, Integer> counter = new HashMap<T, Integer>();
	
	/**
	 * L[ɑΉlCNg܂B
	 * 
	 * @param key L[
	 * @return CNgʂ̒l
	 */
	public int increment(T key){
		Integer count = counter.containsKey(key) ? counter.get(key) + 1 : 1;
		counter.put(key, count);
		
		return count;
	}

	/**
	 * L[ɑΉlfNg܂B
	 * 
	 * @param key L[
	 * @return fNgʂ̒l
	 */
	public int decrement(T key){
		Integer count = counter.containsKey(key) ? counter.get(key) - 1: -1;
		counter.put(key, count);

		return count;
	}

	/**
	 * L[Ƃ̃JEgʂԂ܂B
	 * ̃\bhԋp}bv͕sςłB
	 * (ύXꍇ́ÃNX̃CNgEfNgĂяoĂA߂Ď擾Ă)
	 * 
	 * @return JEg(s)
	 */
	public Map<T, Integer> getResult(){
		return Collections.unmodifiableMap(counter);
	}
}
